package lib.dw;

public class DwAtEncodings
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwAtEncodings (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  public boolean equals (Object o)
  {
    if (o instanceof DwAtEncodings)
      return ((DwAtEncodings) o).enumValue == this.enumValue;
    else
      return false;
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwAtEncodings rhs = (DwAtEncodings) o; // Can throw - ok.
    return rhs.enumValue - this.enumValue;
  }
  static public final int DW_AT_location_ = 0x02;
  static public final DwAtEncodings DW_AT_location = new DwAtEncodings (0x02, "DwAtEncodings_DW_AT_location", "DW AT location", "DW_AT_location");
  static public final int DW_AT_byte_size_ = 0x0b;
  static public final DwAtEncodings DW_AT_byte_size = new DwAtEncodings (0x0b, "DwAtEncodings_DW_AT_byte_size", "DW AT byte size", "DW_AT_byte_size");
  static public final int DW_AT_bit_offset_ = 0x0c;
  static public final DwAtEncodings DW_AT_bit_offset = new DwAtEncodings (0x0c, "DwAtEncodings_DW_AT_bit_offset", "DW AT bit offset", "DW_AT_bit_offset");
  static public final int DW_AT_bit_size_ = 0x0d;
  static public final DwAtEncodings DW_AT_bit_size = new DwAtEncodings (0x0d, "DwAtEncodings_DW_AT_bit_size", "DW AT bit size", "DW_AT_bit_size");
  static public final int DW_AT_const_value_ = 0x1c;
  static public final DwAtEncodings DW_AT_const_value = new DwAtEncodings (0x1c, "DwAtEncodings_DW_AT_const_value", "DW AT const value", "DW_AT_const_value");
  static public final int DW_AT_upper_bound_ = 0x2f;
  static public final DwAtEncodings DW_AT_upper_bound = new DwAtEncodings (0x2f, "DwAtEncodings_DW_AT_upper_bound", "DW AT upper bound", "DW_AT_upper_bound");
  static public final int DW_AT_artificial_ = 0x34;
  static public final DwAtEncodings DW_AT_artificial = new DwAtEncodings (0x34, "DwAtEncodings_DW_AT_artificial", "DW AT artificial", "DW_AT_artificial");
  static public final int DW_AT_data_member_location_ = 0x38;
  static public final DwAtEncodings DW_AT_data_member_location = new DwAtEncodings (0x38, "DwAtEncodings_DW_AT_data_member_location", "DW AT data member location", "DW_AT_data_member_location");
  static public final int DW_AT_decl_file_ = 0x3a;
  static public final DwAtEncodings DW_AT_decl_file = new DwAtEncodings (0x3a, "DwAtEncodings_DW_AT_decl_file", "DW AT decl file", "DW_AT_decl_file");
  static public final int DW_AT_encoding_ = 0x3e;
  static public final DwAtEncodings DW_AT_encoding = new DwAtEncodings (0x3e, "DwAtEncodings_DW_AT_encoding", "DW AT encoding", "DW_AT_encoding");
  static public final int DW_AT_external_ = 0x3f;
  static public final DwAtEncodings DW_AT_external = new DwAtEncodings (0x3f, "DwAtEncodings_DW_AT_external", "DW AT external", "DW_AT_external");
  static public final int DW_AT_frame_base_ = 0x40;
  static public final DwAtEncodings DW_AT_frame_base = new DwAtEncodings (0x40, "DwAtEncodings_DW_AT_frame_base", "DW AT frame base", "DW_AT_frame_base");
  static public final int DW_AT_type_ = 0x49;
  static public final DwAtEncodings DW_AT_type = new DwAtEncodings (0x49, "DwAtEncodings_DW_AT_type", "DW AT type", "DW_AT_type");

  /** Create a HashMap containing all the DwAtEncodings elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (DW_AT_location.enumString, DW_AT_location);
    map.put (DW_AT_byte_size.enumString, DW_AT_byte_size);
    map.put (DW_AT_bit_offset.enumString, DW_AT_bit_offset);
    map.put (DW_AT_bit_size.enumString, DW_AT_bit_size);
    map.put (DW_AT_const_value.enumString, DW_AT_const_value);
    map.put (DW_AT_upper_bound.enumString, DW_AT_upper_bound);
    map.put (DW_AT_artificial.enumString, DW_AT_artificial);
    map.put (DW_AT_data_member_location.enumString, DW_AT_data_member_location);
    map.put (DW_AT_decl_file.enumString, DW_AT_decl_file);
    map.put (DW_AT_encoding.enumString, DW_AT_encoding);
    map.put (DW_AT_external.enumString, DW_AT_external);
    map.put (DW_AT_frame_base.enumString, DW_AT_frame_base);
    map.put (DW_AT_type.enumString, DW_AT_type);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwAtEncodings object that matches the string.  */
  public static DwAtEncodings valueOf (String string)
  {
    return (DwAtEncodings)enumMap.get (string);
  }

  /** Return the DwAtEncodings object that matches the integer.  */
  public static DwAtEncodings valueOf (long i)
  {
    switch ((int)i) {
    case DW_AT_location_: return DW_AT_location;
    case DW_AT_byte_size_: return DW_AT_byte_size;
    case DW_AT_bit_offset_: return DW_AT_bit_offset;
    case DW_AT_bit_size_: return DW_AT_bit_size;
    case DW_AT_const_value_: return DW_AT_const_value;
    case DW_AT_upper_bound_: return DW_AT_upper_bound;
    case DW_AT_artificial_: return DW_AT_artificial;
    case DW_AT_data_member_location_: return DW_AT_data_member_location;
    case DW_AT_decl_file_: return DW_AT_decl_file;
    case DW_AT_encoding_: return DW_AT_encoding;
    case DW_AT_external_: return DW_AT_external;
    case DW_AT_frame_base_: return DW_AT_frame_base;
    case DW_AT_type_: return DW_AT_type;
    default: return null;
    }
  }

  /** Return an array of all the DwAtEncodings elements.  */
  public static DwAtEncodings[] values ()
  {
    return (DwAtEncodings[]) enumMap.values ().toArray (new DwAtEncodings[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwAtEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwAtEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwAtEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwAtEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwAtEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }
}
